#include "CoObj.h"
#include "exception.h"

SObject::SObject (CLSID const & classId)
    :_iUnk (0)
{
    HRESULT hr = S_OK;
    if (_iUnk == 0)
    {
        hr = CoCreateInstance (
                   classId,
                   0,
                   CLSCTX_SERVER,
                   IID_IUnknown,
                   (void**)& _iUnk);
    }
    if (FAILED (hr))
        throw Exception (hr, "Couldn't create instance");
}

void * SObject::AcquireInterface (IID const & iid)
{
    void * p = 0;
    HRESULT hr = _iUnk->QueryInterface (iid, & p);
    if (FAILED (hr))
		throw Exception (hr, "Couldn't acquire interface");
    return p;
}
